﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Net.Mime.MediaTypeNames;

namespace _25AlgAlfabetMorsa
{
    public partial class Form1 : Form
    {
        //ustawienie częstotliwości dźwięku i czasu trwania kropki
        const int _f = 1000, _t = 200;
        String[,] alfabet = new String[60, 2] 
                  {
                   {"A",".-"},{"B","-..."},{"C","-.-."},{"D","-.."},{"E","."},
                   {"F","..-."},{"G","--."},{"H","...."},{"I",".."},{"J",".---"},
                   {"K","-.-"},{"L",".-.."},{"M","--"},{"N","-."},{"O","---"},
                   {"P",".--."},{"Q","--.-"},{"R",".-."},{"S","..."},{"T","-"},
                   {"U","..-"},{"V","...-"},{"W",".--"},{"X","-..-"},{"Y","-.--"},
                   {"Z","--.."},{"Ą",".-.-"},{"Ć",".-..."},{"Ę","..-.."},{"Ł",".-..-"},
                   {"Ń","--.--"},{"Ó","---."},{"Ś","...-..."},{"Ź","--..-."},{"Ż","--..-"},
                   {"1",".----"},{"2","..---"},{"3","...--"},{"4","....-"},{"5","....."},
                   {"6","-...."},{"7","--..."},{"8","---.."},{"9","----."},{"0","-----"},
                   {".",".-.-.-"},{",","--..--"},{"'",".----."},{"\"",".-..-."},{"+","..--.-"},
                   {":","---..."},{";","-.-.-."},{"?","..--.."},{"!","-.-.--"},{"-","-....-"},
                   {"+",".-.-."},{"/","-..-."},{"(","-.--."},{")","-.--.-"},{"=","-...-"}
                  };
        

        public Form1()
        {
            InitializeComponent();
        }

        void znakDzwiek(String tekst,int f, int t)
        {
            //f to czestotliwosc
            //t to czas trwania kropki
            //kreska trwa tyle co dwie kropki
            //odstep pomiedzy elementami znaku trwa tyle co jedna kropka
            //odstep pomiedzy kolejnymi znakami trwa tyle co trzy kropki 
            for(int i = 0; i < tekst.Length; i++)
            {
                switch (tekst[i])
                {
                    case '.': Console.Beep(f, t);break;
                    case '-': Console.Beep(f, 3*t); break;
                }
            }
            //skonczył sie znak morse'a to milcz tyle ile trwa kropka
            Thread.Sleep(t);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //kreska trwa tyle co dwie kropki
            //odstep pomiedzy elementami znaku trwa tyle co jedna kropka
            //odstep pomiedzy kolejnymi znakami trwa tyle co trzy kropki 
            Console.Beep(1000, 200);
            Thread.Sleep(400);
            Console.Beep(1000, 600);
        }


        private void button2_Click(object sender, EventArgs e)
        {
            textBox2.Clear();
            for (int i = 0; i < textBox1.Text.Length; i++)
            {
              //pusty znak kodu morsea
              String kodMorsea = "";
                //szukaj znaku
                for (int j = 0; j < 60; j++)
                {
                    if (textBox1.Text.Substring(i, 1).ToUpper() == alfabet[j, 0])
                        {
                        kodMorsea = alfabet[j, 1];
                        //pokaz zakodowany znak
                        textBox2.AppendText(kodMorsea + " ");
                        //daj dzwiek
                        znakDzwiek(kodMorsea, _f, _t);
                        break;
                        }
                    else
                        if (textBox1.Text.Substring(i, 1).ToUpper() == " ")
                        {
                        //wpisz znak separatora końca słowa
                        textBox2.AppendText("|");
                        Thread.Sleep(3 * _t);
                        break;
                        }
                }
                
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            String znak = "";
            //odkoduj tekst alabetu Morse'a z kontrolki textBox2
            //odkodowany tekst wpisz do textBox3
            textBox3.Clear();
            for (int i = 0; i < textBox2.Text.Length; i++)
            {
                if(textBox2.Text.Substring(i,1)!=" "
                   && textBox2.Text.Substring(i, 1) != "|")
                    znak += textBox2.Text.Substring(i, 1);
                //szukaj odpowiednika litery
                else for (int j = 0; j < 60; j++)
                        if (znak == alfabet[j, 1])
                        {
                            textBox3.AppendText(alfabet[j, 0]);
                            znak = "";
                            break;
                        }
                //wstaw spację gdy trafisz na przyjęty znak separatora wyrazów
                if(textBox2.Text.Substring(i, 1)== "|")
                    textBox3.AppendText(" ");
            }
        }

    }
}
